<script>
/* eslint-disable no-unreachable */
/* eslint-disable no-console */
/* eslint-disable no-debugger */

import ElementView from './ElementView.vue'

export default {
	components: {
		ElementView,
	},
	props: {
		elementUrl: {
			type: String,
			default: '',
		},
		homeserverUrl: {
			type: String,
			default: '',
		},
	},
	data() {
		return {
			errorMessage: null,
			credentials: null,
		}
	},

	/**
	 * Checks if user has credentials and if homeserver is on. Depending on that, shows the element iframe or shows
	 * an error message to the user.
	 *
	 * @return {Promise<void>}
	 */
	async beforeCreate() {

		console.log('beforeCreate1')
		const credentialsResponse = await fetch(window.OC.generateUrl('apps/matrixbridge/matrix_credentials/stored'))
		let hsData = null
		let homeserverResponse = null
		try {
			homeserverResponse = await fetch(this.homeserverUrl + '/_matrix/client/versions')
			hsData = await homeserverResponse.json()
		} catch (error) {
			if (error instanceof TypeError) {
				// Network Error: unable to fetch
			}
		}

		console.log('123')
		const credentialsData = await credentialsResponse.json()

		if (!homeserverResponse || !homeserverResponse.ok) {
			this.errorMessage = 'Matrix homeserver at ' + this.homeserverUrl + ' is unreachable.'
		} else if (!('matrix_token' in credentialsData)) {
			this.errorMessage = credentialsData.error
		} else {
			this.credentials = credentialsData
		}

		// if server is offline/unreachable

		console.log('aaa')
		console.log(credentialsResponse)
		console.log(credentialsData)
		console.log(homeserverResponse)
		console.log(hsData)
	},

	mounted() {
		console.log('app mounted')
	},

}

</script>
<template>
	<div v-if="errorMessage"
		id="matrix_error"
		class="container">
		<div class="alert alert-danger" role="alert">
			<strong>Attention!</strong> {{ errorMessage }}
		</div>
	</div>
	<ElementView v-else-if="credentials" :credentials="credentials" :element-url="elementUrl" />
</template>
